/*
 
 Function for Software-SPI
 Sends a Byte to a 74HC595 connected to port B
 
 void spi(unsigned char);
 
 */
 
 #include <macros.inc>
 #include <ctoasm.inc>
 
 /*
 Which pins should be used for the SPI connection?
 */
 #define MOSI 0
 #define SCK 2
 
 #define value rP1
 #define count rTI0
 
    .global spi
    .func spi
 
 spi:                    //  that's the beginning of the function
    clr count
    
 loop:
    cbi PORTB, MOSI
    rol value
    brcc carrycleared
    sbi PORTB, MOSI
 carrycleared:
    nop
    sbi PORTB, SCK
    nop
    cbi PORTB, SCK
    inc count
    cpi count, 8
    brne loop
 
    ret                   // end of function, return to main program
 
    .endfunc
